// WebScan
// code by jph

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class WebScan
extends TimerTask
implements ActionListener
{
  static final int PERIOD=2000;
  static final String[] _DISP={"Addresses","Emails","Servers","Denials","Exceptions"};
	static final String[] CONSS={"no contact","no connection","completed"};
	static final Color[]  CONSC={Color.red,Color.yellow,Color.green};
	static final String[] RATES={"Servers","Emails"};
	static final Color[]  RATEC={Color.blue,Color.magenta};

	JFrame myJFrame;
	Container myContainer;
	JLabel[] myJLabel;
	static final int FLAG=5;
	
	JCheckBox[] myJCheckBox;
	JButton myJButton;
	JComboBox myJComboBox[];
		
	static final int DISPLAY=9;	
  long[] count;
  long[] size;
  long[] total;

  DataInputStream myDataInputStream;
  OutputStream myOutputStream;
  PrintWriter myPrintWriter;
	InputStream myInputStream;	

  DataMonitor[] myDataMonitor;
  java.util.Timer myTimer;
  BotenAnna myBotenAnna;
  long myLong=0;
  boolean launched=false;

	public static void main(String[] args) {  	
  	WebScan myWebScan=new WebScan();
  }
  
  public WebScan() {
    int c1;
    String myString;
    String myServer;
    myBotenAnna=new BotenAnna();    
		myJFrame=new JFrame("WebScan Boten-Anna ["+new Date()+" "+myBotenAnna.session+"]");
		myJComboBox=new JComboBox[10];
		myJLabel=new JLabel[8];
  	myContainer=new Container();
  	myContainer.setLayout(new BorderLayout());
  		JToolBar myJToolBar=new JToolBar();
  		myJToolBar.add(myJLabel[FLAG]=new JLabel(" ",new ImageIcon("res/flag.us.gif"),JLabel.LEFT));
  		  myJComboBox[BotenAnna.COUNTRY]=new JComboBox(BotenAnna._COUNTRY);
  		  myJComboBox[BotenAnna.COUNTRY].setToolTipText("country of search");
  		  myJComboBox[BotenAnna.COUNTRY].setSelectedIndex(0);
  		  myJComboBox[BotenAnna.COUNTRY].addActionListener(this);
  		myJToolBar.add(myJComboBox[BotenAnna.COUNTRY]);
  		myJToolBar.addSeparator();
  		
    try {
      myDataInputStream=new DataInputStream(new BufferedInputStream(new FileInputStream("var/seeds.txt")));      
      while ((myString=myDataInputStream.readLine())!=null)
        if (myString.toLowerCase().startsWith("htt")) {
          System.out.println("seed "+myString);
          myServer=myBotenAnna.getServer(myString);
          myBotenAnna.myCountry=myServer.substring(myServer.lastIndexOf(46)+1);
          myJComboBox[BotenAnna.COUNTRY].setSelectedItem(myBotenAnna.myCountry);
          myBotenAnna.myLinkedList_add(myString);
        }
      myDataInputStream.close();
    } catch (IOException myIOException) {
      System.out.println(myIOException);
    }	
  		
  		myJToolBar.add(new JLabel(" ",new ImageIcon("res/icon.map.gif"),JLabel.LEFT));
 				myJComboBox[BotenAnna.MAX_LINKS_PER_SERVER]=new JComboBox(BotenAnna._LINKS_PER_SERVER);
 				myJComboBox[BotenAnna.MAX_LINKS_PER_SERVER].setToolTipText("max addresses per server");
 				myJComboBox[BotenAnna.MAX_LINKS_PER_SERVER].setSelectedIndex(6);
 			myJToolBar.add(myJComboBox[BotenAnna.MAX_LINKS_PER_SERVER]);
 			myJToolBar.addSeparator();
 			myJToolBar.add(new JLabel(" ",new ImageIcon("res/icon.eye.jpg"),JLabel.LEFT));
  		  myJComboBox[DISPLAY]=new JComboBox(_DISP);
  		  myJComboBox[DISPLAY].setSelectedIndex(1);
  		  myJComboBox[DISPLAY].setToolTipText("display in console");
  		myJToolBar.add(myJComboBox[DISPLAY]);  		
 			myJToolBar.addSeparator();
 			  myJButton=new JButton("",new ImageIcon("res/icon.go_.gif"));				
   			myJButton.setToolTipText("stop all threads");
   			myJButton.addActionListener(this);
   		myJToolBar.add(myJButton);
	  myContainer.add("North",myJToolBar);
	  JPanel myJPanel;
	    myJPanel=new JPanel();	  
	    myJPanel.setLayout(new GridLayout(2,1));	    
			myDataMonitor=new DataMonitor[2];    	
    	myDataMonitor[0]=new DataMonitor("Addresses",CONSS,CONSC);
    	myDataMonitor[0].setMargin(1,1);
    	myDataMonitor[0].setTimers(200,20000);    	
    	myDataMonitor[0].redraw=PERIOD;
    	myDataMonitor[1]=new DataMonitor("",RATES,RATEC);
    	myDataMonitor[1].setMargin(1,1);
    	myDataMonitor[1].setTimers(200,20000);    	
    	myDataMonitor[1].redraw=PERIOD;
    	for (c1=0;c1<2;c1++) {
     	  myDataMonitor[c1].setMinimumSize(new Dimension(100,100));
    	  myDataMonitor[c1].setPreferredSize(new Dimension(100,130));
    	  myJPanel.add(myDataMonitor[c1]);
  	  }
  	myContainer.add("Center",myJPanel);
	    myJPanel=new JPanel();
	    myJPanel.setLayout(new GridLayout(1,4));     	
     	  myJLabel[0]=new JLabel("0",new ImageIcon("res/icon.crr.png"),JLabel.LEFT);
     	  myJLabel[0].setToolTipText("connections and size of queued connections");
     	  myJLabel[1]=new JLabel("0",new ImageIcon("res/icon.egg.gif"),JLabel.LEFT);
     	  myJLabel[1].setToolTipText("total servers");
     	  myJLabel[2]=new JLabel("0",new ImageIcon("res/icon.www.png"),JLabel.LEFT);
     	  myJLabel[2].setToolTipText("total addresses");
     	  myJLabel[3]=new JLabel("0",new ImageIcon("res/icon.adr.png"),JLabel.LEFT);
     	  myJLabel[3].setToolTipText("total emails");
     	for (c1=0;c1<4;c1++)
     	  myJPanel.add(myJLabel[c1]);
  	myContainer.add("South",myJPanel);
	    myJPanel=new JPanel();
	    myJPanel.setLayout(new GridLayout(BotenAnna._CLASS.length,1));
     	myJCheckBox=new JCheckBox[BotenAnna._CLASS.length];
     	for (c1=0;c1<BotenAnna._CLASS.length;c1++) {
       	myJCheckBox[c1]=new JCheckBox(BotenAnna._CLASS[c1]);
       	myJCheckBox[c1].setToolTipText("visit "+BotenAnna._CLASS[c1]+" domains");
       	myJCheckBox[c1].setSelected(myBotenAnna.visit[c1]);
       	myJPanel.add(myJCheckBox[c1]);
     	}
  	myContainer.add("East",myJPanel);
  	
		myJFrame.getContentPane().add(myContainer);
		myJFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent myWindowEvent) { System.exit(0);}});			
		myJFrame.setLocation(600,20);
    myJFrame.setSize(500,300);
    myJFrame.setVisible(true);
    
    count=new long[4];
    size=new long[4];
    total=new long[4];
    myTimer=new java.util.Timer();    
  }
  
  public void run() {
    int c1;
    long time=myBotenAnna.session+myLong;
    long l0,l1,l2;
    l0=myBotenAnna.count[myBotenAnna.CONTACTED]-count[myBotenAnna.CONTACTED];
    l1=myBotenAnna.count[myBotenAnna.CONNECTED]-count[myBotenAnna.CONNECTED];
    l2=myBotenAnna.count[myBotenAnna.COMPLETED]-count[myBotenAnna.COMPLETED];
    myDataMonitor[0].add(0,time,Math.max(l0-l1,0));
    myDataMonitor[0].add(1,time,Math.max(l1-l2,0));
    myDataMonitor[0].add(2,time,l2);
    count[myBotenAnna.CONTACTED]=myBotenAnna.count[myBotenAnna.CONTACTED];
    count[myBotenAnna.CONNECTED]=myBotenAnna.count[myBotenAnna.CONNECTED];
    count[myBotenAnna.COMPLETED]=myBotenAnna.count[myBotenAnna.COMPLETED];
    
    l0=myBotenAnna.myHashSet[myBotenAnna.DOM].size();
    l1=myBotenAnna.myHashSet[myBotenAnna.ADR].size();
    l2=myBotenAnna.myHashSet[myBotenAnna.EML].size();
    total[myBotenAnna.DOM]+=l0-size[myBotenAnna.DOM];
    total[myBotenAnna.ADR]+=l1-size[myBotenAnna.ADR];
    total[myBotenAnna.EML]+=l2-size[myBotenAnna.EML];
    myDataMonitor[1].add(0,time,Math.max(l0-size[myBotenAnna.DOM],0));    
    myDataMonitor[1].add(1,time,Math.max(l2-size[myBotenAnna.EML],0));
    size[myBotenAnna.DOM]=l0;
    size[myBotenAnna.ADR]=l1;
    size[myBotenAnna.EML]=l2;
    if (myBotenAnna.myHashSet[myBotenAnna.DOM].size()>BotenAnna.HASH_DOM) {
      myBotenAnna.reduce_DOM();
      size[myBotenAnna.DOM]=myBotenAnna.myHashSet[myBotenAnna.DOM].size();
    }
    if (myBotenAnna.myHashSet[myBotenAnna.ADR].size()>BotenAnna.HASH_ADR) {
      myBotenAnna.reduce(myBotenAnna.myHashSet[myBotenAnna.ADR]);
      size[myBotenAnna.ADR]=myBotenAnna.myHashSet[myBotenAnna.ADR].size();
    }
    if (myBotenAnna.myHashSet[myBotenAnna.EML].size()>BotenAnna.HASH_EML) {
      myBotenAnna.reduce(myBotenAnna.myHashSet[myBotenAnna.EML]);    
      size[myBotenAnna.EML]=myBotenAnna.myHashSet[myBotenAnna.EML].size();
    }
    myJLabel[0].setText(myBotenAnna.count[myBotenAnna.CONTACTED_NOW]+" <"+myBotenAnna.myLinkedList.size()+">");    
    myJLabel[1].setText(""+total[myBotenAnna.DOM]);//+" ["+size[myBotenAnna.DOM]+"]"+myBotenAnna.myHashtable[myBotenAnna.DOM].size());
    myJLabel[2].setText(""+total[myBotenAnna.ADR]);//+" ["+size[myBotenAnna.ADR]+"]");
    myJLabel[3].setText(""+total[myBotenAnna.EML]);//+" ["+size[myBotenAnna.EML]+"]");
    
    myBotenAnna.param[BotenAnna.MAX_LINKS_PER_SERVER]=Integer.parseInt(""+myJComboBox[myBotenAnna.MAX_LINKS_PER_SERVER].getSelectedItem());
    myBotenAnna.system_out=1<<myJComboBox[DISPLAY].getSelectedIndex();
    for (c1=0;c1<BotenAnna._CLASS.length;c1++)
      myBotenAnna.visit[c1]=myJCheckBox[c1].isSelected();
    myBotenAnna.myCountry=(String)myJComboBox[BotenAnna.COUNTRY].getSelectedItem();
    
    myLong+=PERIOD;
    
    try {
      myBotenAnna.myBufferedWriter[myBotenAnna.LOG].flush();
      myBotenAnna.myBufferedWriter[myBotenAnna.EML].flush();
	  } catch (IOException myIOException) {
	  	System.out.println(myIOException);
	  }        
  }
  
	public void actionPerformed(ActionEvent myActionEvent) {
	  int c1=0,c2;	  
	  if (myActionEvent.getSource()==myJButton)
	    if (launched) {
  	    myBotenAnna.myBoolean=false;
  	    myTimer.cancel();
		  } else {
    	  myJButton.setIcon(new ImageIcon("res/icon.sto.gif"));
    	  launched=true;
        myTimer.scheduleAtFixedRate(this,PERIOD,PERIOD);
        myBotenAnna.myThread_start();  	  
  		}
		if (myActionEvent.getSource()==myJComboBox[BotenAnna.COUNTRY]) {
  		myJLabel[FLAG].setIcon(new ImageIcon("res/flag."+myJComboBox[BotenAnna.COUNTRY].getSelectedItem()+".gif"));
		}
	}

}
